//#include "ShaderCommon.fx"
//
//Texture2D<float4> InputTexture;
//
//struct GBuffer
//{
//	float4 color		: SV_Target0;
//	float4 normalDepth	: SV_Target1;
//	float4 wpos			: SV_Target2;
//};
//
//GBuffer CreateGBufferPS(DefaultVertexOut input)
//{
//	GBuffer output = (GBuffer)0;
//
//	output.color = input.color;
//	output.normalDepth.xyz = input.normal * 0.5f + 0.5f;
//	output.normalDepth.w = -mul(input.position, ProjectionInverse).z / cameraParams.y;	// Linear view space depth
//	output.wpos = input.wpos;
//	return output;
//}
//
//GBuffer CreateGBufferTexturedPS(DefaultVertexOut input)
//{
//	GBuffer output = (GBuffer)0;
//	output.color = InputTexture.Sample(BilinearWrapSampler, input.uv);
//	output.normalDepth.xyz = input.normal * 0.5f + 0.5f;
//	output.normalDepth.w = -mul(input.position, ProjectionInverse).z / cameraParams.y;	// Linear view space depth
//	output.wpos = input.wpos;
//	return output;
//}
//
//[numthreads(16,16,1)]
//void GenerateTiledLightingCS(uint3 dtid : SV_DispatchThreadID)
//{
//
//}
//
//float4 RenderColorBufferPS(FullScreenVertexOut input) : SV_Target0
//{
//	return ColorBuffer.Sample(PointClampSampler, input.uv);
//}
//
//float4 RenderNormalBufferPS(FullScreenVertexOut input) : SV_Target0
//{
//	return float4(NormalDepthBuffer.Sample(PointClampSampler, input.uv).xyz, 1.0f);
//}
//
//float4 RenderDepthBufferPS(FullScreenVertexOut input) : SV_Target0
//{
//	//float d = getLinearDepth(DepthBuffer.SampleLevel(PointClampSampler, input.uv, 0).r);
//	float d = DepthBuffer.SampleLevel(PointClampSampler, input.uv, 0).r;
//	return float4(d.xxx, 1.0f);
//}
//
//float4 RenderWorldPosBufferPS(FullScreenVertexOut input) : SV_Target0
//{
//	return float4(WorldPosBuffer.SampleLevel(PointClampSampler, input.uv, 1.0f).xyz, 1.0f);
//}
//
//float4 CompositePS(FullScreenVertexOut input) : SV_Target0
//{
//	float3 color = float3(0.0f, 0.0f, 0.0f);
//
//	// Get normal and world space position
//	float3 normal = NormalDepthBuffer.SampleLevel(PointClampSampler, input.uv, 0).xyz * 2.0f - 1.0f;
//	float3 wpos = WorldPosBuffer.SampleLevel(PointClampSampler, input.uv, 0).xyz;
//	float3 baseColor = ColorBuffer.SampleLevel(PointClampSampler, input.uv, 0).xyz;
//
//	// Sum all of the point light contributions
//	//[unroll]
//	//for(int i = 0; i < MAX_POINT_LIGHTS; ++i)
//	//{
//	//	color += renderPointLight(pointLights[i], baseColor, wpos, normal);
//	//}
//
//	// Add directional lighting contribution
//	[unroll]
//	for(int j = 0; j < MAX_DIRECTIONAL_LIGHTS; ++j)
//	{
//		color += renderDirectionalLight(directionalLights[j], baseColor, normal);
//	}
//
//	color += baseColor * ambLightColor.xyz;
//	return float4(saturate(color.xyz), 1.0f);
//}